# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2022-2024 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---
device_type: n1sdp
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 480

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/n1sdp/acs_suite.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  extra_nfsroot_args: ',vers=3'
  extra_kernel_args: rootwait

actions:
#
# Any firmware bundle deployed must be configured to boot automatically without
# intervention. This means "PMIC_FORCE" must be set "TRUE" in the config file
# to be deployed.
#
#
# Deploy a firmware bundle with the customized "uefi.bin" installed. This
# enables an EFI network driver, allowing us to force a TFTP boot from GRUB (assuming cobbler is setup)
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip


- deploy:
    namespace: debian
    to: tftp
    os: debian
    kernel:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/linux
      type: image
    ramdisk:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/ramdisk.img
    nfsrootfs:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/debian-buster-arm64-rootfs.tar.xz
      compression: xz


- boot:
    namespace: recovery
    timeout:
      minutes: 10
    method: minimal
    parameters:
      kernel-start-message: ''
    prompts: ['Cmd>']


- boot:
    namespace: uart1
    method: new_connection
    connection: uart1


- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: device-network
            description: '"Test device network connection"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - |
                cat <<- "EOF" > /etc/systemd/network/wired.network
                [Match]
                Name=e*
                [Network]
                DHCP=yes
                KeepConfiguration=dhcp
                [DHCP]
                CriticalConnection=true
                EOF
              - systemctl restart systemd-networkd
              - apt -q update
              - apt -q install -y iputils-ping
              - ping -c 5 {{ LAVA_HOST_IP }} || lava-test-raise "Device failed to reach a remote host ({{ LAVA_HOST_NAME }})"
              - hostname -I | grep -q $(lava-target-ip) # || lava-test-raise "Device is not at assigned IP address"
        from: inline
        name: device-network
        path: inline/device-network.yaml


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: install-dependencies
            description: '"Install dependencies for secondary media deployment"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - apt-get update -q
              - apt-get install -qy bmap-tools
        from: inline
        name: install-dependencies
        path: inline/install-dependencies.yaml


#
# Deploy the ACS image and the corresponding bmap file stored as artifacts by the build job
# First modify the image to select the sequence file
#
- deploy:
    namespace: secondary_media
    to: downloads
    timeout:
      minutes: 20
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: bz2
      udhcp:
        url: "https://git.busybox.net/busybox/plain/examples/udhcp/simple.script"
    postprocess:
      docker:
        image: {{ CI_REGISTRY_IMAGE }}/utility-image:{{ DOCKER_IMAGE_TAG }}
        steps:
          - wget -O jfrog https://releases.jfrog.io/artifactory/jfrog-cli/v2/[RELEASE]/jfrog-cli-linux-arm64/jfrog
          - mv simple.script udhcpd.script
          - gdisk -l {{ IR_IMG }}
          - |
            guestfish --rw -a {{ IR_IMG }} << EOF
            launch
            list-filesystems
            mount /dev/sda1 /
            copy-out /EFI/BOOT/bbr/SCT/Sequence/EBBR.seq .
            ls /
            umount /
            EOF
          - splitter.py --splits {{ TOTAL_SEQUENCE_FILES }} EBBR.seq {{ SEQUENCE_FILE_PREFIX }}
          - mv {{ SEQUENCE_FILE_PREFIX }}_{{ SEQUENCE_FILE_NUMBER }}.seq EBBR.seq
          - |
            guestfish --rw -a {{ IR_IMG }} << EOF
            launch
            list-filesystems
            mount /dev/sda1 /
            glob rm-rf /EFI/BOOT/bbr/SCT/Sequence/*
            copy-in EBBR.seq /EFI/BOOT/bbr/SCT/Sequence/
            umount /
            mount /dev/sda2 /
            copy-in jfrog /
            copy-in udhcpd.script /
            ls /
            umount /
            EOF
          - bmaptool create -o {{ IR_IMG }}.bmap {{ IR_IMG }}

- deploy:
    namespace: secondary_media
    connection-namespace: uart1
    timeout:
      minutes: 10
    to: usb
    os: oe
    images:
      image:
        url: "downloads://{{ IR_IMG }}"
      bmap:
        url: "downloads://{{ IR_IMG }}.bmap"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} {DEVICE}
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9ms\.\ ]+, copying speed [0-9\.]+ MiB\/sec']



#
# Deploy the cassini primary board firmware bundle stored as an artifact by the build job
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: zip


- boot:
    namespace: secondary_media
    timeout:
      minutes: 400
    method: minimal
    auto_login:
      login_prompt: '/ # '
      username: root
      login_commands:
        - mkdir /mnt_boot
        - mount /dev/sda1 /mnt_boot
        - cp -a /mnt_boot/EFI/BOOT/bbr/SCT/Overall /mnt/acs_results/sct_results/
        - cp -a /mnt_boot/EFI/BOOT/bbr/SCT/Dependency/EfiCompliantBBTest /mnt/acs_results/sct_results/
        - cp -a /mnt_boot/EFI/BOOT/bbr/SCT/Sequence /mnt/acs_results/sct_results/
        - umount /mnt
        - umount /mnt_boot
    prompts:
      - '/ #'


- deploy:
    namespace: recovery
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip


- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '


- test:
    namespace: debian
    timeout:
      minutes: 65
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: upload-acs-reports
            description: '"Upload ACS reports"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - echo "{{ ARTIFACTORY_HOST_IP }} {{ ARTIFACTORY_HOST_NAME }}" >> /etc/hosts
              - echo "{{ NTP_HOST_IP }} {{ NTP_HOST_NAME }}" >> /etc/hosts
              - apt -q update
              - apt -q install -y curl
              - curl -fL https://getcli.jfrog.io/v2 | sh
              - cp jfrog /usr/bin/
              - chmod 755 /usr/bin/jfrog
              - jfrog config add artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - lsblk
              - mkdir acs
              - mount /dev/sda2 acs
              - lsblk
              - cd acs
              - echo "CI_PROJECT_PATH={{ CI_PROJECT_PATH }}" > acs_results/buildata.txt
              - echo "CI_JOB_NAME={{ CI_JOB_NAME }}" >> acs_results/buildata.txt
              - echo "CI_JOB_ID={{ CI_JOB_ID }}" >> acs_results/buildata.txt
              - rm -rf acs_results/uefi_dump
              - ls -laR acs_results
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "acs_results/",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/",
                      "flat": "false",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard "${build_name}" --max-builds=20 --max-days=30 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
        from: inline
        name: upload-acs-reports
        path: inline/upload-acs-reports.yaml

- test:
    namespace: debian
    timeout:
      minutes: 2
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: dump_upload_log
            description: '"Output Upload log"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
            - cat /home/root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: output-upload-log
        path: inline/output-upload-log.yaml
